TagLib::ID3v2::RelativeVolumeFrame Class Reference

An ID3v2 relative volume adjustment frame implementation. More...

`#include <relativevolumeframe.h>`

Inheritance diagram for TagLib::ID3v2::RelativeVolumeFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::RelativeVolumeFrame:
[legend]

## Classes

struct | PeakVolume
| Struct that stores the relevant values for ID3v2 peak volume. More...

## Public Types

enum | ChannelType { Other = 0x00 , MasterVolume = 0x01 , FrontRight = 0x02 , FrontLeft = 0x03 , BackRight = 0x04 , BackLeft = 0x05 , FrontCentre = 0x06 , BackCentre = 0x07 , Subwoofer = 0x08 }

## Public Member Functions

| RelativeVolumeFrame ()
| RelativeVolumeFrame (const ByteVector &data)
| ~RelativeVolumeFrame () override
| RelativeVolumeFrame (const RelativeVolumeFrame &)=delete
RelativeVolumeFrame & | operator= (const RelativeVolumeFrame &)=delete
String | toString () const override
List< ChannelType > | channels () const
short | volumeAdjustmentIndex (ChannelType type=MasterVolume) const
void | setVolumeAdjustmentIndex (short index, ChannelType type=MasterVolume)
float | volumeAdjustment (ChannelType type=MasterVolume) const
void | setVolumeAdjustment (float adjustment, ChannelType type=MasterVolume)
PeakVolume | peakVolume (ChannelType type=MasterVolume) const
void | setPeakVolume (const PeakVolume &peak, ChannelType type=MasterVolume)
String | identification () const
void | setIdentification (const String &s)
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
| Frame (const Frame &)=delete
Frame & | operator= (const Frame &)=delete
ByteVector | frameID () const
unsigned int | size () const
unsigned int | headerSize () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual StringList | toStringList () const
ByteVector | render () const
Header * | header () const

## Protected Member Functions

void | parseFields (const ByteVector &data) override
ByteVector | renderFields () const override
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=nullptr)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const
virtual PropertyMap | asProperties () const

## Friends

class | FrameFactory

## Additional Inherited Members

Static Public Member Functions inherited from TagLib::ID3v2::Frame
static ByteVector | textDelimiter (String::Type t)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)
Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An ID3v2 relative volume adjustment frame implementation.

This is an implementation of ID3v2 relative volume adjustment. The presence of this frame makes it possible to specify an increase in volume for an audio file or specific audio tracks in that file.

Multiple relative volume adjustment frames may be present in the tag each with a unique identification and describing volume adjustment for different channel types.

## Member Enumeration Documentation

## ChannelType

enum TagLib::ID3v2::RelativeVolumeFrame::ChannelType

This indicates the type of volume adjustment that should be applied.

Enumerator
Other | A type not enumerated below.
MasterVolume | The master volume for the track.
FrontRight | The front right audio channel.
FrontLeft | The front left audio channel.
BackRight | The back right audio channel.
BackLeft | The back left audio channel.
FrontCentre | The front center audio channel.
BackCentre | The back center audio channel.
Subwoofer | The subwoofer audio channel.

## Constructor & Destructor Documentation

## RelativeVolumeFrame() [1/3]

TagLib::ID3v2::RelativeVolumeFrame::RelativeVolumeFrame | ( |  | ) |

Constructs a RelativeVolumeFrame. The relevant data should be set manually.

Referenced by operator=(), RelativeVolumeFrame(), and renderFields().

## RelativeVolumeFrame() [2/3]

TagLib::ID3v2::RelativeVolumeFrame::RelativeVolumeFrame | ( | const ByteVector & | data | ) |

Constructs a RelativeVolumeFrame based on the contents of data.

## ~RelativeVolumeFrame()

TagLib::ID3v2::RelativeVolumeFrame::~RelativeVolumeFrame | ( |  | ) |

override

Destroys the RelativeVolumeFrame instance.

## RelativeVolumeFrame() [3/3]

TagLib::ID3v2::RelativeVolumeFrame::RelativeVolumeFrame | ( | const RelativeVolumeFrame & |  | ) |

delete

References RelativeVolumeFrame().

## Member Function Documentation

## channels()

List< ChannelType > TagLib::ID3v2::RelativeVolumeFrame::channels | ( |  | ) | const

Returns a list of channels with information currently in the frame.

## identification()

String TagLib::ID3v2::RelativeVolumeFrame::identification | ( |  | ) | const

Returns the identification for this frame.

## operator=()

RelativeVolumeFrame & TagLib::ID3v2::RelativeVolumeFrame::operator= | ( | const RelativeVolumeFrame & |  | ) |

delete

References RelativeVolumeFrame().

## parseFields()

void TagLib::ID3v2::RelativeVolumeFrame::parseFields | ( | const ByteVector & | data | ) |

override protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Implements TagLib::ID3v2::Frame.

## peakVolume()

PeakVolume TagLib::ID3v2::RelativeVolumeFrame::peakVolume | ( | ChannelType | type = MasterVolume | ) | const

Returns the peak volume (represented as a length and a string of bits).

This defaults to returning the value for the master volume channel if available and returns 0 if the specified channel does not exist.

See also
  setPeakVolume()

References MasterVolume.

## renderFields()

ByteVector TagLib::ID3v2::RelativeVolumeFrame::renderFields | ( |  | ) | const

override protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Implements TagLib::ID3v2::Frame.

References RelativeVolumeFrame(), and TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## setIdentification()

void TagLib::ID3v2::RelativeVolumeFrame::setIdentification | ( | const String & | s | ) |

Sets the identification of the frame to s. The string is used to identify the situation and/or device where this adjustment should apply.

## setPeakVolume()

void TagLib::ID3v2::RelativeVolumeFrame::setPeakVolume | ( | const PeakVolume & | peak,
|  | ChannelType | type = MasterVolume )

Sets the peak volume to peak.

By default this sets the value for the master volume.

See also
  peakVolume()

References MasterVolume.

## setVolumeAdjustment()

void TagLib::ID3v2::RelativeVolumeFrame::setVolumeAdjustment | ( | float | adjustment,
|  | ChannelType | type = MasterVolume )

Set the relative volume adjustment in decibels to adjustment.

By default this sets the value for the master volume.

Note
  Because this is actually stored internally as an "index" to this value the value set by this method may not be identical to the one returned by volumeAdjustment().

See also
  setVolumeAdjustment()
  volumeAdjustmentIndex()

References MasterVolume.

## setVolumeAdjustmentIndex()

void TagLib::ID3v2::RelativeVolumeFrame::setVolumeAdjustmentIndex | ( | short | index,
|  | ChannelType | type = MasterVolume )

Set the volume adjustment to index. As indicated by the ID3v2 standard this is a 16-bit signed integer that reflects the decibels of adjustment when divided by 512.

By default this sets the value for the master volume.

See also
  volumeAdjustmentIndex()
  setVolumeAdjustment()

References MasterVolume.

## toString()

String TagLib::ID3v2::RelativeVolumeFrame::toString | ( |  | ) | const

override virtual

Returns the frame's identification.

See also
  identification()

Implements TagLib::ID3v2::Frame.

## volumeAdjustment()

float TagLib::ID3v2::RelativeVolumeFrame::volumeAdjustment | ( | ChannelType | type = MasterVolume | ) | const

Returns the relative volume adjustment in decibels.

Note
  Because this is actually stored internally as an "index" to this value the value returned by this method may not be identical to the value set using setVolumeAdjustment().

This defaults to returning the value for the master volume channel if available and returns 0 if the specified channel does not exist.

See also
  setVolumeAdjustment()
  volumeAdjustmentIndex()

References MasterVolume.

## volumeAdjustmentIndex()

short TagLib::ID3v2::RelativeVolumeFrame::volumeAdjustmentIndex | ( | ChannelType | type = MasterVolume | ) | const

Returns the relative volume adjustment "index". As indicated by the ID3v2 standard this is a 16-bit signed integer that reflects the decibels of adjustment when divided by 512.

This defaults to returning the value for the master volume channel if available and returns 0 if the specified channel does not exist.

See also
  setVolumeAdjustmentIndex()
  volumeAdjustment()

References MasterVolume.

## Friends And Related Symbol Documentation

## FrameFactory

friend class FrameFactory

friend

References FrameFactory.

Referenced by FrameFactory.

The documentation for this class was generated from the following file:

- relativevolumeframe.h